'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var getterAndSetter = {
    get: true,
    set: true
};

var Property = (function (_Node) {
    _inherits(Property, _Node);

    function Property(childNodes) {
        _classCallCheck(this, Property);

        _get(Object.getPrototypeOf(Property.prototype), 'constructor', this).call(this, 'Property', childNodes);
    }

    _createClass(Property, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = undefined;
            var value = undefined;
            var shorthand = false;
            var method = false;
            var computed = false;
            var kind = undefined;

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;
                children.passToken();
                children.skipNonCode();

                computed = children.isToken('Punctuator', '[');
                key = readKey(children);
                children.skipNonCode();

                value = children.passNode('FunctionExpression');
            } else {
                if (children.isToken('Punctuator', '*')) {
                    children.passToken();
                    children.skipNonCode();
                }

                kind = 'init';
                computed = children.isToken('Punctuator', '[');
                key = readKey(children);

                if (children.isEnd && key.type === 'Identifier') {
                    shorthand = true;
                    value = key;
                } else {
                    children.skipNonCode();
                    if (children.isNode('FunctionExpression')) {
                        method = true;
                        value = children.passNode('FunctionExpression');
                    } else {
                        children.passToken('Punctuator', ':');
                        children.skipNonCode();
                        if (children.currentElement.isPattern) {
                            value = children.passPattern();
                        } else {
                            value = children.passExpression();
                        }
                    }
                }
            }

            children.assertEnd();

            this._kind = kind;
            this._key = key;
            this._value = value;
            this._shorthand = shorthand;
            this._computed = computed;
            this._method = method;
        }
    }, {
        key: 'key',
        get: function get() {
            return this._key;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'shorthand',
        get: function get() {
            return this._shorthand;
        }
    }, {
        key: 'method',
        get: function get() {
            return this._method;
        }
    }, {
        key: 'computed',
        get: function get() {
            return this._computed;
        }
    }]);

    return Property;
})(_Node3['default']);

exports['default'] = Property;

function readKey(children) {
    if (children.isNode('Literal') || children.isNode('Identifier')) {
        return children.passNode();
    } else {
        children.passToken('Punctuator', '[');
        children.skipNonCode();
        var result = children.passExpression();
        children.skipNonCode();
        children.passToken('Punctuator', ']');
        return result;
    }
}
module.exports = exports['default'];